#include "FreeRTOS.h"

#include "fiq.h"

//
//
//
static volatile unsigned int fiqCounter;

//
//
//
void fiqInit (void)
{
  SCB_PCONP |= SCB_PCONP_PCTIM1;

  VIC_IntSelect |= VIC_IntSelect_Timer1;
  VIC_IntEnable = VIC_IntEnable_Timer1;

  T1_PR = 0;
  T1_MR0 = configCPU_CLOCK_HZ / 8;
  T1_MCR = T_MCR_MR0R | T_MCR_MR0I;
}

int fiqEnable (void)
{
  unsigned int state = T1_TCR;

  T1_TCR = T_TCR_CE;

  return (state & T_TCR_CE) ? 1 : 0;
}

int fiqDisable (void)
{
  unsigned int state = T1_TCR;

  T1_TCR = T_TCR_CR;

  return (state & T_TCR_CE) ? 1 : 0;
}

unsigned int fiqGetCount (void)
{
  return fiqCounter;
}

void fiqClearCount (void)
{
  fiqCounter = 0;
}

void fiqISR (void) __attribute__ ((interrupt ("FIQ")));
void fiqISR (void)
{
  ++fiqCounter;

  T1_IR = T_IR_MASK;
}
